#pragma once
#include "IPC.h"
#include "Window.h"
#include <os/IPC.h>

struct Client
{
    OwnedPtr<os::IPC::ClientConnection> conn;
    Vector<Window*> windows;
    const bool privileged { false };
    bool should_be_disconnected { false };

    Client(OwnedPtr<os::IPC::ClientConnection>&& client, bool priv)
#ifdef CLIENT_IMPLEMENTATION
        : conn(move(client)), windows(), privileged(priv)
    {
        conn->set_message_handler(wind::handle_ipc_message, this);
    }
#else
        ;
#endif
};
